#include "stdafx.h"
#include <commdlg.h>
#include <shlobj.h>
#include "CommonDlg.h"

///////////////////////////////////////////////////////////////////////////////
// OpenFileBox - Opens the Open File Dialog box
///////////////////////////////////////////////////////////////////////////////

BOOL OpenFileBox(HWND hwnd, char* FileName, int NameLength, char* Filter)
{
	OPENFILENAME File;
	ZeroMemory(&File, sizeof(OPENFILENAME));

	File.lStructSize = sizeof(File);
	File.hwndOwner = hwnd;
	File.lpstrFilter = Filter;
	File.nFilterIndex = 1;
	File.lpstrFile = FileName;
	File.nMaxFile = NameLength;
	File.lpstrTitle = "Open";
	File.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

	return(GetOpenFileName(&File));
}



///////////////////////////////////////////////////////////////////////////////
// OpenFolderSelectBox - Opens a SHBrowse Shell to return a directory
///////////////////////////////////////////////////////////////////////////////

BOOL OpenFolderSelectBox(HWND hwnd, char* DirName)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	IMalloc* pMalloc;
	static char TempDir[MAX_PATH];

	
	if(FAILED(SHGetMalloc(&pMalloc)))
		return FALSE;


      bi.hwndOwner = hwnd;									// owner window
      bi.pidlRoot = NULL; //GetModuleFileName(NULL, TempDir, 255);	// folder to start in - NULL for My Computer
      bi.pszDisplayName = DirName;							// pointer to string that gets folder display name
      bi.lpszTitle = "Select a Folder";								// pointer to text to display in window
      bi.ulFlags = BIF_RETURNONLYFSDIRS;					// flags - see API docs for BROWSEINFO
      bi.lpfn = NULL;										// callback function - usually not needed
      bi.lParam = 0;										// parameter to callback function

      pidl = SHBrowseForFolder(&bi);

      if(!pidl)
         return FALSE;

      if(!SHGetPathFromIDList(pidl, DirName))
         return FALSE;

      pMalloc->Free(pidl);
      pMalloc->Release();

      return TRUE;
}