#include "stdafx.h"
#include <windows.h>
#include "NumberBox.h"

WNDPROC EditProc = NULL;

// Limit text to 8 hexadecimal digits
BOOL HookEditToNumberEdit(HWND hEdit)
{
	EditProc = (WNDPROC)GetClassLong(hEdit, GCL_WNDPROC);
	SendMessage(hEdit, EM_LIMITTEXT, 8, 0);
	SetWindowLong(hEdit, GWL_WNDPROC, (LONG)NumberEditProc);
	return TRUE;
}

// Don't need to call this unless you want to revert back to a regular edit box
BOOL UnhookNumberEdit(HWND hNumberEdit)
{
	SendMessage(hNumberEdit, EM_LIMITTEXT, 0, 0);
	SetWindowLong(hNumberEdit, GWL_WNDPROC, (LONG)EditProc);
	return TRUE;
}

LRESULT CALLBACK NumberEditProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CHAR:
		switch(wParam)
		{
		case '0': case '1': case '2': case '3': case '4': case '5': case '6':
		case '7': case '8': case '9': case 'A': case 'a': case 'B': case 'b':
		case 'C': case 'c': case 'D': case 'd': case 'E': case 'e': case 'F':
		case 'f': case '\b':
			return CallWindowProc(EditProc, hwnd, uMsg, wParam, lParam);
		}
		return 0;
	default:
		break;
	}

	return CallWindowProc(EditProc, hwnd, uMsg, wParam, lParam);
}