#pragma once

const unsigned int PsExeHeaderLength = 0x800;

// Struct completely ripped from PCSX 1.5 source
typedef struct
{
	unsigned char id[8];
	unsigned long text;
	unsigned long data;
	unsigned long pc0;
	unsigned long gp0;
	unsigned long t_addr;	// Base offset
	unsigned long t_size;	// Image size, minus header
	unsigned long d_addr;
	unsigned long d_size;
	unsigned long b_addr;
	unsigned long b_size;
	unsigned long s_addr;
	unsigned long s_size;
	unsigned long SavedSP;
	unsigned long SavedFP;
	unsigned long SavedGP;
	unsigned long SavedRA;
	unsigned long SavedS0;
} PSEXE_HEADER;

bool OpenPsExeFile(const char* Filename, PSEXE_HEADER* ExeHeader);