#pragma once

const unsigned int SS_SUCCESS = 0;
const unsigned int SS_NOFILE = 1;
const unsigned int SS_BADFILE = 2;
const unsigned int SS_MEMERR = 3;

typedef struct
{
	char id[3];
	unsigned int size; // Size of the section

	unsigned int data; // Buffer position of section data
} EPSXE_SECTION;

typedef struct
{
	char id[0x40];        // "ePSXe " and sony license number
	EPSXE_SECTION PsxPsx; // "PSX"
	EPSXE_SECTION PsxMem; // "MEM"
	EPSXE_SECTION PsxReg; // "REG"
	EPSXE_SECTION PsxIrq; // "IRQ"
	EPSXE_SECTION PsxGte; // "GTE"
	EPSXE_SECTION PsxCdr; // "CDR"
	EPSXE_SECTION PsxSio; // "SIO"
	EPSXE_SECTION PsxMde; // "MDE"
	EPSXE_SECTION PsxGpu; // "GPU"
	EPSXE_SECTION PsxSpu; // "SPU"

	// Version 0x02 specific
	EPSXE_SECTION PsxPbo; // "PBO"?  "PBOSS"?  Not sure...
	// May be more sections after this, couldn't find them

	unsigned int version; // Current 0x00 and 0x02 supported...
} EPSXE_SAVESTATE;

unsigned int OpenEpsxeSavestate(const char* Filename, EPSXE_SAVESTATE* Savestate);